<template>
  <v-alert
      v-if="success"
      type="success"
      closable
      title="ส่งคำขอเปลี่ยนเปลี่ยนรหัสผ่านเรียบร้อย"
      text="กรุณาตรวจสอบกล่องจดหมายในอีเมลของท่าน"
  />
  <div class="container">
    <v-card class="card">
      <div class="lo-icon">
        <v-btn variant="text" icon="mdi-arrow-left" to="/login"></v-btn>
      </div>

      <h2 class="text-center mb-6">ลืมรหัสผ่าน</h2>
      <v-form @submit.prevent="onSubmit">
        <v-text-field
          v-model="email"
          :rules="[emailRules.required, emailRules.check]"
          ref="emailField"
          label="อีเมล"
          placeholder="example@rmuti.ac.th"
          variant="solo"
          rounded="xl"
          density="comfortable"
          clearable
          type="email"
        ></v-text-field>

        <v-btn
          :loading="loading"
          :disabled="!email || !emailCheck(email)"
          type="submit"
          block
          class="submit-btn"
          size="large"
          variant="flat"
          rounded="xl"
          >ยืนยัน</v-btn
        >
      </v-form>
    </v-card>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | ลืมรหัสผ่าน",
  meta: [{ name: "description", content: "ลืมรหัสผ่าน" }],
});
// ปิด layout
definePageMeta({
  layout: false,
});

import { ref } from "vue";

const { forgotPassword } = useStrapiAuth()
const router = useRouter()

const email = ref()
const loading = ref(false)
const success = ref(false)

const emailRules = {
  required: (value) => !!value || "กรุณากรอกที่อยู่อีเมล",
  check: (value) => {
    const pattern = /^[^\s@]+@[^\s@]+\.[^\s@]+$/; // Regular expression pattern for basic email format
    const domain = "@rmuti.ac.th";
    if (!value) return true; // Return true if the value is empty, because it's not required
    if (!pattern.test(value)) return "รูปแบบอีเมลไม่ถูกต้อง"; // Check if the email format is valid
    if (!value.endsWith(domain)) return `ที่อยู่อีเมลต้องเป็น @rmuti.ac.th`; // Check if the email ends with "@rmuti.ac.th"
    return true; // Return true if all checks pass
  },
};

const emailCheck = (value) => value && value.endsWith("@rmuti.ac.th");

async function onSubmit() {
  loading.value = true;
  setTimeout(() => (loading.value = false), 2000);

  try {
    await forgotPassword({ email: email.value })
    success.value = true
    setTimeout(() => (success.value = false), 5000)
  } catch (e) {}
}
</script>

<style scoped>
@import url(../assets/css/styles/form-card.css);
</style>
